#include "defines.h"

//============================================================
void UpdateChaseCam(edict_t *ent) {
	vec3_t torigin, ownerv, goal;
	edict_t *targ,*old;
	vec3_t oldgoal, angles, forward, right;
	trace_t tr;
	int i;
	
	// is our chase target gone?
	if (!ent->client->chase_target->inuse
		|| ent->client->chase_target->client->resp.spectator) {
		old=ent->client->chase_target;
		ChaseNext(ent);
		if (ent->client->chase_target == old) {
			ent->client->chase_target=NULL;
			ent->client->ps.pmove.pm_flags &= ~PMF_NO_PREDICTION;
			return; } }
	
	targ=ent->client->chase_target;
	
	VectorCopy(targ->s.origin, ownerv);
	VectorCopy(ent->s.origin, oldgoal);
	
	ownerv[2] += targ->viewheight;
	
	VectorCopy(targ->client->v_angle, angles);
	if (angles[PITCH] > 56)
		angles[PITCH]=56;
	AngleVectors(angles, forward, right, NULL);
	VectorNormalize(forward);
	VectorMA(ownerv, -30, forward, torigin);
	
	if (torigin[2] < targ->s.origin[2]+20)
		torigin[2]=targ->s.origin[2]+20;
	
	// jump animation lifts
	if (!targ->groundentity)
		torigin[2] += 16;
	
	tr=gi.trace(ownerv, NULL, NULL, torigin, targ, MASK_SOLID);
	
	VectorCopy(tr.endpos, goal);
	
	VectorMA(goal, 2, forward, goal);
	
	// pad for floors and ceilings
	VectorCopy(goal, torigin);
	torigin[2] += 6;
	tr=gi.trace(goal, NULL, NULL, torigin, targ, MASK_SOLID);
	if (tr.fraction != 1.0) {
		VectorCopy(tr.endpos, goal);
		goal[2] -= 6; }
	
	VectorCopy(goal, torigin);
	torigin[2] -= 6;
	tr=gi.trace(goal, NULL, NULL, torigin, targ, MASK_SOLID);
	if (tr.fraction != 1.0) {
		VectorCopy(tr.endpos, goal);
		goal[2] += 6; }
	
	ent->client->ps.pmove.pm_type=(targ->deadflag==DEAD_DEAD)?PM_DEAD:PM_FREEZE;
	
	VectorCopy(goal, ent->s.origin);
	for (i=0; i<3; i++)
		ent->client->ps.pmove.delta_angles[i]=ANGLE2SHORT(targ->client->v_angle[i]-ent->client->resp.cmd_angles[i]);
	
	if (targ->deadflag==DEAD_DEAD) {
		ent->client->ps.viewangles[ROLL]=40;
		ent->client->ps.viewangles[PITCH]=-15;
		ent->client->ps.viewangles[YAW]=targ->client->killer_yaw; }
	else {
		VectorCopy(targ->client->v_angle, ent->client->ps.viewangles);
		VectorCopy(targ->client->v_angle, ent->client->v_angle); }
	
	ent->viewheight=0;
	ent->client->ps.pmove.pm_flags |= PMF_NO_PREDICTION;
	gi.linkentity(ent);
}

//============================================================
void ChaseNext(edict_t *ent) {
	int i;
	edict_t *e;
	
	if (!ent->client->chase_target)
		return;
	
	i=ent->client->chase_target-g_edicts;
	do {
		i++;
		i=(i>ga.maxclients)?i=1:i;
		e=g_edicts+i;
		if (!e->inuse) continue;
		if (!e->client->resp.spectator) break;
	} while (e != ent->client->chase_target);
	
	ent->client->chase_target=e;
	ent->client->update_chase=true;
}

//============================================================
void ChasePrev(edict_t *ent) {
	int i;
	edict_t *e;
	
	if (!ent->client->chase_target)
		return;
	
	i=ent->client->chase_target-g_edicts;
	do {
		i--;
		i=(i<1)?i=ga.maxclients:i;
		e=g_edicts+i;
		if (!e->inuse) continue;
		if (!e->client->resp.spectator) break;
	} while (e != ent->client->chase_target);
	
	ent->client->chase_target=e;
	ent->client->update_chase=true;
}

//============================================================
void GetChaseTarget(edict_t *ent) {
	int i;
	edict_t *other;
	
	for (i=1; i<=ga.maxclients; i++) {
		other=g_edicts+i;
		if (other->inuse && !other->client->resp.spectator) {
			ent->client->chase_target=other;
			ent->client->update_chase=true;
			UpdateChaseCam(ent);
			return; } }
	
	gi_centerprintf(ent, "No other players to chase.");
}

